<!---Processes the order--->
<cfif ISDEFINED('form.ExpMonth')>
	<cfset CCExpireDate = '#form.ExpMonth#/#form.ExpYear#'>
</cfif>

<cfif NOT ISDEFINED('form.ExpMonth')>
	<cfset CCExpireDate = '#form.CreditCardExpireDate#'>
</cfif>

<cfinclude template = "../queries/qryCompanyinfo.cfm">

<!---Insert the customers email address into the database to generate the customerID.  This is done
for simplicity sake (i.e. not just inserting all info here but below using an UPDATE statement) because
in the full version customer accounts are established and things are handled differently.  Therefore, I did
not want to rewrite the code for this version, so if you are wondering, that's why it's like this--->

	<CFQUERY Name = "AddACustomer" Datasource = "#request.dsn#">
	INSERT INTO CustomerHistory
	(EmailAddress)
	VALUES
	('#form.EmailAddress#')
	</cfquery>
		
<!---Now get the unique database ID Number for this customer to use when processing the order--->
<cfquery name = "GetCustomerID" Datasource = "#Request.dsn#">
SELECT * FROM CustomerHistory
WHERE EmailAddress = '#form.EmailAddress#'
</cfquery>

<cfoutput query = "GetCustomerID">
<cfset Cart.CustomerID = #CustomerID#>
</cfoutput>
			
<cfset TheMemo = #form.Memo#>

<cfif isdefined('form.ShipFromState')>
	<cfset TheMemo = TheMemo & ' - Ship Items from #form.ShipFromState#, #form.ShipFromCountry#'>
</cfif>

<cfoutput query = "qryCompanyInfo">
<cfset TheCompanyName = '#CompanyName#'>
<cfset TheCompanyEmail = '#EmailAddress#'>
<cfset TheCustomerEmail = '#Form.Emailaddress#'>
<cfset TheMailServer = '#MailServer#'>
<cfset GatewayToUse = '#PaymentGateway#'>
</cfoutput>

<!---Set the total shipping costs to a variable so it can be changed if needed--->
<cfset CartVar.ShippingCharges = '#form.TotalShippingCosts#'>
<cfset CartVar.ShippingMethod = 'N/A'>

<cfif ISDEFINED('form.ShippingMethod')>
<cfset CartVar.ShippingMethod = '#form.ShippingMethod#'>
</cfif>

<!---if UPS shipping is turned on and the form field exists then determine the shipping costs--->
<cfif ISDEFINED('form.UPSShipping')>
	<cfset CartVar.ShippingMethod = '#ListGetAt(form.UPSShipping, 1)#'>
	<cfset CartVar.ShippingCharges = '#ListGetAt(form.UPSShipping, 2)#'>
</cfif>

<!---Create a date variable to determine when the order was placed--->
<cfset TheCurrentDate = #Now()#>
<cfset TheCurrentDate = #dateformat(TheCurrentDate, "mm/dd/yyyy")#>

<!---If they accept credit cards check for gateway, process through the correct one--->
<cfif form.PaymentMethod IS 'CreditCard'>

<!---Process through an Authorize.net gateway--->
<cfif GatewayToUse IS 'AuthorizeNet'>
  <!---This is where you could put authorizenet code to process the credit card.
  		You would have to open the database though and change the PaymentGateWay column in the
		CompanyInfo Table to 'AuthorizeNet'--->
</cfif>
</cfif>

<!---Add the customers info into the database--->
<CFQUERY Name = "AddACustomer" Datasource = #request.dsn#>
UPDATE CustomerHistory
SET FirstName= '#Form.FirstName#', 
LastName='#form.LastName#', 
BusinessName='#form.BusinessName#', 
Address='#Form.destaddress#', 
Address2='#form.destaddress2#',
City='#Form.destcity#', 
State='#Form.deststate#', 
ZipCode='#Form.destpostal#', 
Country='#Form.destcountry#', 
PhoneNumber='#Form.PhoneNumber#', 
EmailAddress='#form.EmailAddress#', 
CreditCardType='#form.CreditCardType#', 
CreditCardNumber='#form.CreditCardNumber#', 
CreditCardExpire='#CCExpireDate#', 
ShipFirstName='#form.ShipFirstName#', 
ShipLastName='#form.ShipLastName#', 
ShipBusinessName='#form.ShipBusinessName#', 
ShipAddress='#form.ShipAddress#', 
ShipAddress2='#form.ShipAddress2#',
ShipCity='#form.ShipCity#', 
ShipState='#form.ShipState#', 
ShipZip='#form.ShipZip#', 
ShipCountry='#form.ShipCountry#'
WHERE CustomerID = #Cart.CustomerID#
</CFQUERY>

<!---Create a value for the shippedto field--->
<cfset TempVar.ShippedTo = '#form.ShipFirstName# #form.ShipLastName#<br> #form.ShipBusinessName# <br>
#form.ShipAddress# <br> #form.ShipCity#, #form.ShipState#  #form.ShipZip#<br>#form.ShipCountry#'>
<!---Now Dump the shopping cart contents into the database along with other info about this order--->

<cfif NOT ISDEFINED('session.CrtProductID')>
ERROR:  Your session has expired or you tried to access this page from the wrong URL
<cfabort>
</cfif>

<cflock scope="Session" type="EXCLUSIVE" timeout="10">
<cfoutput>
<cfset cart.CrtProductID = '#session.CrtProductID#'>
<cfset cart.CrtProductName = '#session.CrtProductName#'>
<cfset cart.CrtQuantity = '#session.CrtQuantity#'>
<cfset cart.CrtPrice = '#session.CrtPrice#'>
<cfset Cart.CrtThumbNails = '#session.CrtThumbNails#'>
<cfset Cart.CrtItemID = '#session.CrtItemID#'>
</cfoutput>
</cflock>

<!----check to make sure a duplicate order isn't being inserted--->
<cfquery name = "CheckDuplicateOrders" datasource="#Request.dsn#">
SELECT * FROM Orders
WHERE OrderNumber = '#form.OrderNumber#'
</cfquery>

<!---If there is a duplicate, delete it before inserting the order--->
<cfif NOT CheckDuplicateOrders.recordcount IS 0>
<CFQUERY Name = "RemoveDuplicate" Datasource = "#request.dsn#">
Delete * 
FROM Orders
WHERE OrderNumber = '#form.OrderNumber#'
</CFQUERY>
</cfif>

<CFQUERY Name = "AddOrderedItemsToDatabase" Datasource = #request.dsn#>
INSERT INTO Orders
(OrderNumber, CustomerID, CrtItemID, CrtProductID, CrtProductName, CrtPrice, CrtQuantity, QuotedShipping, 
FiguredTax, OrderStatus, DateOfOrder, PaymentMethod, OrderCompleted, ShippingMethod,  
OrderTotal, ShippedTo, memo, TrackingNumber)
VALUES
('#form.OrderNumber#', '#Cart.CustomerID#', '#Cart.CrtItemID#', '#Cart.CrtProductID#', '#Cart.CrtProductName#',
'#Cart.CrtPrice#', '#Cart.CrtQuantity#', '#CartVar.ShippingCharges#', '#form.FiguredTax#', 'In Process',
'#TheCurrentDate#', '#form.PaymentMethod#', 'No', '#CartVar.ShippingMethod#', '#form.OrderTotal#', '#TempVar.ShippedTo#', '#TheMemo#', '0')
</CFQUERY>

<!---Now send notification to the Company's email inbox--->
<cfif NOT #form.PaymentMethod# IS 'PayPalCheckout'>
<cfif NOT CheckDuplicateOrders.recordcount IS 0>
<CFMAIL
    FROM="#TheCompanyEmail#"
    TO="#TheCompanyEmail#"
    SUBJECT="Website Order Notification"
	SERVER="#TheMailServer#">

You just received an order on your website!
The Order Number assigned was:  #form.OrderNumber#
Logon to the admin page to view the order.
</cfmail>
</cfif>

<cfoutput>
<CFLOCATION URL="docheckout.cfm?action=finalize&CustomerID=#Cart.CustomerID#&OrderNumber=#form.OrderNumber#"></cfoutput>
</cfif>