
<!---Set a default value--->
<cfset WasInThere = 'No'>

<!---Create temporary variables to use instead of accessing the session variables over and over.  NOTE:
sessions are locked in order to make the application more stable--->

<cflock scope="Session" type="EXCLUSIVE" timeout="10">
<cfoutput>
<cfset cart.CrtItemID = '#session.CrtItemID#'>
<cfset cart.CrtProductID = '#session.CrtProductID#'>
<cfset cart.CrtProductName = '#session.CrtProductName#'>
<cfset cart.CrtQuantity = '#session.CrtQuantity#'>
<cfset cart.CrtPrice = '#session.CrtPrice#'>
<cfset cart.CrtThumbNails = '#session.CrtThumbNails#'>
</cfoutput>
</cflock>

<!---If the session variables are defined but the first one is empty, make sure they are all 
empty to prevent errors...this is just a backup.  The sesion variables are created in application.cfm
if they are not already created.--->
<cfif isdefined('session.CrtProductName')>
<cfif cart.CrtProductName IS "">
<cflock scope="SESSION" type="EXCLUSIVE" timeout="10">
	<cfset session.CrtItemID="">
	<cfset session.CrtProductID="">
	<cfset session.CrtProductName = "">
	<cfset session.CrtQuantity = "">
	<cfset session.CrtPrice = "">
	<cfset session.CrtThumbNails = "">
</cflock>
</cfif>
</cfif>

<!--- Look in the cart and see if there are any duplicate items.  If so, then
     ignore the request to add the time to the cart--->
   
<cfoutput>
<cfif NOT #ListLen(cart.CrtProductName, "^")# IS 0>
<cfloop index="LoopCount" FROM="1" TO="#ListLen(cart.CrtProductID, "^")#">
<CFIF #ListGetAt(cart.CrtProductName, loopcount, "^")# IS #form.ProductName#>
	<CFSET WasInThere = 'Yes'>
</CFIF>
</cfloop>
</cfif>
</cfoutput>
<cfif #WasInThere# IS 'Yes'>
<CFLOCATION URL="index.cfm?Action=View">
</cfif>

<!---Update the cart Contents--->
<cfoutput>
<CFSET NewItemID = ListAppend(#cart.CrtItemID#, #form.ItemID#, "^")>
<CFSET cart.CrtItemID = #NewItemID#>
<CFSET NewProdID = ListAppend(#cart.CrtProductID#, #form.ProductID#, "^")>
<CFSET cart.CrtProductID = #NewProdID#>
<CFSET NewProductName = ListAppend(#cart.CrtProductName#, #form.ProductName#, "^")>
<CFSET cart.CrtProductName = #NewProductName#>
<CFSET NewQuantity = ListAppend(#cart.CrtQuantity#, #form.Quantity#, "^")>
<CFSET cart.CrtQuantity = #NewQuantity#>

<cfset TotalOfItems = #form.Price# * #form.Quantity#>
<CFSET NewPrice = ListAppend(#cart.CrtPrice#, #TotalOfItems#, "^")>
<CFSET cart.CrtPrice = #NewPrice#>
<cfset NewThumbNail = ListAppend(#Cart.CrtThumbNails#, #form.ThumbNail#, "^")>
<cfset Cart.CrtThumbnails = #NewThumbNail#>
</cfoutput>

<!---Now write the temporary variables back to the session variables--->
<cflock scope="SESSION" type="EXCLUSIVE" timeout="10">
<cfoutput>
<cfset session.CrtItemID = '#Cart.CrtItemID#'>
<cfset session.CrtProductID = '#cart.CrtProductID#'>
<cfset session.CrtProductName = '#cart.CrtProductName#'>
<cfset session.CrtQuantity = '#cart.CrtQuantity#'>
<cfset session.CrtPrice = '#cart.CrtPrice#'>
<cfset session.CrtThumbnails = '#Cart.CrtThumbNails#'>
</cfoutput>
</cflock>

<!---Now lets go view the cart!--->
<CFLOCATION URL="index.cfm?action=View">